---
- name: Assert that windows domain join properties are defined
  ansible.builtin.assert:
    that:
      - windows_join_domain is mapping
      - windows_join_domain.domain is defined
      - windows_join_domain.netbios_domain is defined
      - windows_join_domain.netbios_domain is string
      - windows_join_domain.dns_servers is defined
      - windows_join_domain.dns_servers is iterable
      - windows_join_domain.domain is string
      - windows_join_domain.join_account is defined
      - windows_join_domain.join_account is string
      - windows_join_domain.join_password is defined
      - windows_join_domain.join_password is string
      - windows_join_domain.ou_path is defined
      - windows_join_domain.ou_path is string
    fail_msg: >
      "Make sure windows_join_domain (mapping) variable has dns_servers (array of string) domain (string), join_account (string), join_password (number) and ou_path (string) properties set"
    quiet: true

- name: Set DNS Servers
  ansible.windows.win_dns_client:
    adapter_names: '*'
    dns_servers: "{{ windows_join_domain.dns_servers }}"

- name: Join Active Directory domain
  ansible.windows.win_domain_membership:
    dns_domain_name: "{{ windows_join_domain.domain }}"
    domain_admin_user: "{{ windows_join_domain.netbios_domain }}\\{{ windows_join_domain.join_account }}"
    domain_admin_password: "{{ windows_join_domain.join_password }}"
    domain_ou_path: "{{ windows_join_domain.ou_path }}"
    state: domain
  register: domain_state

- name: Reboot after domain join
  ansible.windows.win_reboot:
  when: domain_state.reboot_required

- name: Wait for system to become reachable
  ansible.builtin.wait_for_connection:
    timeout: 900
...
